#if 0
C -o ini ini.o interpreter.o -s Interpreter=Main -di interpreter.h -di ini.h -i :: -d mac -d EVAL_FLOATING -d ALLOW_RUNON_WSP -d EXAMPLE {"Parameters"}
Exit 0
#endif
/*
 ini.c
  interpreter 1.7.1

 Created: 2013.03.25
 Revised: 2013.04.24
*/

#include "../enviro64.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "interpreter.h"
#include "ini.h"

/* ---- code */

int deltobj(tobj *o)
{
	if (o->z>0 && o->s)
		{free(o->s); o->s = NULL, o->z = 0; return 1;}
	return 0;
}

const tcon *gettcon(const tcon *l,
	const tobj *o)
{
	long		z = o->z&0x7FFFFFFF;

	for(; l->d; ++l)
		if (!memcmp(o->s,l->s,z) && !l->s[z])
			return l;
	return NULL;
}

int settrec(const trec *l,
	const tobj *d,
	const tobj *s,
	int8 *p,
	int8 lit)
{
	const char	*u, *e;
	long		z = d->z&0x7FFFFFFF, t, typ;

	if (!l)
		return -1;
	while(1)
	{
		if ((t=ABS(l->z))==0)
			return -1;
		if (!memcmp(d->s,l->s,z) && !l->s[z])
			break;
		++l;
	}
	p+= l->o, z = s->z&0x7FFFFFFF, u = s->s, e = u+z;
	if ((typ=l->z)<-255)
	{
		const char	*n = NULL;
		double		v;
		int8		uns;

		if (typ>=_hint64)
			if (lit)
			{
				if (z>8)
					goto bdat;
				if (parse_literal(u,(int64*)&v,z)<0)
					return -3;
			t5:	switch(-typ&3)
				{
				default: *p = int64lo(*(int64*)&v); break;
				case 1: *(int16*)p = int64lo(*(int64*)&v); break;
				case 2: *(int32*)p = int64lo(*(int64*)&v); break;
				case 3: *(int64*)p = *(int64*)&v;
				}
				return 0;
			} else if ((n=readanyint64(u,e,(int64*)&v))!=NULL
					&& (n>=e || *n!='.'))
				goto t5;
	next:	if (n)
			u = n;
		uns = 0;
		if ((n=parse_number(u,e,&v,1))!=NULL)
		{
			if (*(u=n)=='u' || *u=='U')
				++u, uns = 1;
		} else if (z==4)
			if (!memcmp(u,"true",4) || !memcmp(u,"TRUE",4))
				v = 1, u+= 4;
			else if (!memcmp(u,"-inf",4) || !memcmp(u,"-INF",4))
				v =-INFINITY, u+= 4;
			else
				goto tbool;
		else if (z==5 && (!memcmp(u,"false",5) || !memcmp(u,"FALSE",5)))
			v = 0, u+= 5;
		else if (z==3 && (!memcmp(u,"inf",3) || !memcmp(u,"INF",3)))
			v = INFINITY, u+= 3;
		else
		tbool:	if (typ==_bool)
				v = s->z ? *u:0;
			else
				goto bdat;
		switch(typ)
		{
		case _int8: if (v>IMAX(int8)) *(int8*)p = IMAX(int8); else *(int8*)p = v; break;
		case _int16: case _pt16: case _rgb48: case _rect16:
			if (l->z==_rgb48)
				if (v<0 && !uns)
					v = 0;
				else if (v>32767)
					v-= 65536;
			if (v>IMAX(int16)) *(int16*)p = IMAX(int16); else *(int16*)p = v; break;
		case _ifract: v*= 16384;
		case _ifixed: v*= 65536, v+= v<0 ? -.5:.5;
		case _int32: if (v>IMAX(int32)) *(int32*)p = IMAX(int32); else *(int32*)p = v; break;
		case _int64: if (v>=-IMIN64) int64sethl(*(int64*)p,IMAX(int32),-1ul); else int64xset(*(int64*)p,v); break;
		case _ufrc8: v*= 256, v+= .5;
		case _uint8: case _hint8:
			if (v<0 && uns)
				v+= 256;
			if (v>0xFF) *(uint8*)p = 0xFF; else *(uint8*)p = v; break;
		case _ufrc16: v*= 65536, v+= .5;
		case _uint16: case _hint16:
			if (v<0 && uns)
				v+= 65536;
			if (v>0xFFFF) *(uint16*)p = 0xFFFF; else *(uint16*)p = v; break;
		case _ufrc32: v*= 4;
		case _ufract: v*= 16384;
		case _ufixed: v*= 65536, v+= .5;
		case _uint32: case _hint32:
			if (v<0 && uns)
				v+= 4294967296.0;
			if (v>-1ul) *(uint32*)p = -1ul; else *(uint32*)p = v; break;
		case _uint64: case _hint64:
			if (v<0 && uns)
				v+=-2*IMIN64;
			if (v>=-2*IMIN64) int64sethl(*(int64*)p,-1ul,-1ul); else int64xset(*(uint64*)p,v); break;
		case _bool: *(int8*)p = v!=0; break;
		case _float: *(float*)p = v; break;
		case _double: *(double*)p = v; break;
		case _flt16: *(float*)&v = v;
			if (~*(int32*)&v&0x7F800000)
				*(int32*)&v+= 0x8000;
			*(int16*)p = ((int16*)&v)[!BIG_ENDIAN];
			break;

		bdat:
		default: return -3;
		}
		u = parse_skipwsp(u,e);
		if (*u==',')
		{
			if ((unsigned)typ-_rect16<=_rgb48-_rect16)
				++typ, p+= 2;
			else if (typ==_pt16)
				typ = _uint16, p+= 2;
			else
				return -3;
			u = parse_skipwsp(u+1,e), n = NULL;
			goto next;
		}
	} else
	{
		if (typ<0)
			++p;
		memset(p,0,ABS(typ)); /* zero out undefined chars */
		if (z>=t)
			z = t;
		else
			p[z] = 0; /* C termination */
		if (typ<0)
			p[-1] = z;
		memcpy(p,u,z);
	}
	return 0;
}

static const char *id_break(const char *str,
	const char *e)
{
	const char	*s = str;

	while(s<e)
		switch(*s)
		{
		case '_':
		case '.':
		case ',':
		case ' ':
		case '+':
		case '-':
		CASE_NUMERIC
		CASE_ALPHABETIC
		next:	++s;
			break;

		default:
#ifdef CHR_NB
			if (*s==CHR_NB)
				goto next;
#endif
			goto wsp;
		}
wsp:	while(s>str)
		if (*--s!=' ')
			{++s; break;}
	return s;
}

static int read_line(const char *str,
	const char *e,
	const tcon *l,
	const tcon **c,
	int8 *com)
{
	tobj		o[2];
	const char	*s;
	int		t;
	int8		lit;

	if ((s=str)==NULL)
		return -1;
	o->z = o[1].z = t = 0, o->s = o[1].s = NULL;
	if (*com)
	{ /* C-style comment */
		while(s<e)
			if (*s++=='*' && s<e && *s++=='/')
				goto start;
		goto term;
	}
start:	*com = 0, lit = 0;
	while(s<e)
	{
		switch((uint8)*s) /* try not to get stuck */
		{
		case '/':
			++s;
			if (s>=e)
				goto err;
			if (*s=='*')
			{ /* C-style comment */
				*com = 1;
				while(s<e)
					if (*s++=='*' && *s++=='/')
						goto start;
				goto term;
			} else if (*s!='/') /* C++-style comment */
				goto err;
		case ';': /* old-style comment */
			goto term;
		case '\\':
			if (*++s=='\\')
				goto err;
			break;
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case ' ':
			s = parse_skipwsp(s+1,e);
			break;
		case '=':
			if (t)
				goto err; 
			++t, ++s;
			break;
		case '.':
			if (!t)
				goto err;
		case '-':
		case '+':
		CASE_NUMERIC
		CASE_ALPHABETIC
			if (t>1 || o[t].s)
				goto err;
			o[t].s = (char*)s; /* shouldn't be altered */
			if ((s=id_break(s,e))==NULL)
				goto err;
			o[t].z = (s-o[t].s)|0x80000000u;
			if (!t)
				break;
			goto obj;
		case '\047':
			lit = 1;
		case '"':
			if (o[t].s || !l || !l->p)
				goto err;
			o[t].z =-1u>>1;
			if ((s=parse_textloop(s,e,&o[t].z,NULL,&o[t].s,0,NULL))==NULL
					|| o[t].z<0)
				{o[t].z = 1; goto err;}
			++s; /* to skip endquote */
			if (!t)
				break;
		obj:	if ((t=settrec((**c).d,o,o+1,(**c).p,lit))!=0)
				goto end;
			t = 1;
			break;
		case '[':
			if (t)
				goto err;
			s = parse_skipwsp(s+1,e);
			if (s>=e)
				goto err;
			s = id_break(o->s=(char*)s,e);
			o->z = (s-o->s)|0x80000000u;
			s = parse_skipwsp(s,e);
			if (s>=e || *s++!=']')
				goto err;
			if ((*c=gettcon(l,o))==NULL)
				goto err;
			break;

		default:
		err:	t = s-str;
			goto end;
		}
	}
term:	if (t==1)
		t = 0;
end:	deltobj(o), deltobj(o+1);
	return t;
}

long read_ini(FILE *f,
	const tcon *cl,
	long m)
{
	const tcon	*rc = NULL;
	char		*s, com = 0;
	uint32		z, l, x = 1;

	s = malloc(0); /* needed for first-empty line(s) case */
	while(z=~0,l=x,f && (s=freadline(f,&z,s,NULL,&x,'\\'))!=NULL)
	{
		const char	*e = s+z;
		long		r;

		if ((r=read_line(parse_skipwsp(s,e),e,cl,&rc,&com)&m)!=0)
			fprintf(stderr,"## read_ini, line %d: %s\n",
				l,r==-3 ? "bad data":r>0 ? "no record":"no entry");
	}
	if (z)
		z = _e_memory_error;
	free(s);

	return z;
}

static double_t fix2double(uint32 v,
	int s, /* binary scale - negate for 'signed' */
	int c) /* maximum fraction digit count */
{
	double_t	r = scal10(scalb(s<0 ? (int32)v:v,-ABS(s)),c), e;

	if ((e=fmod(r,10))<2) /* low-threshold round */
		r-= e;
	else if (e>9) /* high-threshold round */
		r+= 10, r-= e;
	else /* normal round */
		r+= .5, r-= fmod(r,1);
	return scal10(r,-c);
}

int print_trec(FILE *f,
	const trec *l,
	const int8 *p)
{
	long		z, r;

	p+= l->o;
	if (l->z<-255)
	{
		char		b[32];
		double		v;

		switch(l->z)
		{
		case _hint8: z = *(const uint8*)p; goto h10;
		case _hint16: z = *(const uint16*)p; goto h10;
		case _hint32: z = *(const uint32*)p;
		h10:	return fprintf(f,"%s=0x%X",
				l->s,z);
		case _hint64:
			return fprintf(f,"%s=0x%llX",
				l->s,*(const uint64*)p);
		case _int8: z = *(const int8*)p; goto i10;
		case _int16: z = *(const int16*)p; goto i10;
		case _int32: z = *(const int32*)p;
		i10:	return fprintf(f,"%s=%d",
				l->s,z);
		case _int64:
			return fprintf(f,"%s=%lld",
				l->s,*(const int64*)p);
		case _uint8: z = *(const uint8*)p; goto u10;
		case _uint16: z = *(const uint16*)p; goto u10;
		case _uint32: z = *(const uint32*)p;
		u10:	return fprintf(f,"%s=%u",
				l->s,z);
		case _uint64:
			return fprintf(f,"%s=%llu",
				l->s,*(const uint64*)p);
		case _bool: z = *(const int8*)p!=0; goto u10;
		case _ufrc8: v = fix2double(*(const uint8*)p,8,3); break;
		case _ufrc16: z = *(const uint16*)p, r = 16; goto frc;
		case _ufrc32: r = 32; goto x30;
		case _ifixed: r =-16; goto ifrc;
		case _ufixed: r = 16;
		ifrc:	z = *(const int32*)p;
		frc:	v = fix2double(z,r,5);
			break;
		case _ifract: r =-30; goto x30;
		case _ufract: r = 30;
		x30:	v = fix2double(*(const int32*)p,r,10);
			break;
		case _flt16:
			*(int32*)b = 0;
			((int16*)b)[!BIG_ENDIAN] = *(const int16*)p;
			return fprintf(f,"%s=%.4g",
				l->s,*(float*)b);
		case _float:
			return fprintf(f,"%s=%.8g",
				l->s,*(const float*)p);
		case _double: v = *(const double*)p; break;
		case _pt16:
			return fprintf(f,"%s=%d,%d",
				l->s,*(int16*)p,((int16*)p)[1]);
		case _rgb48:
			return fprintf(f,"%s=%u,%u,%u",
				l->s,*(uint16*)p,((uint16*)p)[1],((uint16*)p)[2]);
		case _rect16:
			return fprintf(f,"%s=%d,%d,%d,%d",
				l->s,*(int16*)p,((int16*)p)[1],((int16*)p)[2],((int16*)p)[3]);

		default: return -1;
		}
		sprintf(b,"%.16g",
			v);
		return fprintf(f,"%s=%s",
			l->s,*b=='0' && b[1]=='.' ? b+1:b);
	} else
	{
		r = fprintf(f,"%s=\"",
			l->s);
		if ((z=l->z)<0)
		{
			z =-z;
			if (*(const uint8*)p<z)
				z = *(const uint8*)p;
			++p;
		} else /* don't print trailing nulls (C-string default) */
			while(z)
				if (p[--z])
					{++z; break;}
		r+= print_tchars(f,p,z,'"');
		r+= fputc('"',f);
		return r;
	}
}

long dump_ini(FILE *f,
	const tcon *l)
{
	const trec	*r;
	long		t = 0;

	for(; (r=l->d)!=0; ++l)
		for(t+=fprintf(f,"\n[%s]\n", l->s); r->z; ++r)
			t+= print_trec(f,r,l->p), t+= fputc('\n',f);
	return t;
}

#ifdef EXAMPLE
typedef struct example_rec
{
	double		doub;
	float		sing;
	int64		llng;
	ifract		ifrc;
	ifixed		ifix;
	int32		lint;
	int16		shrt;
	int8		ctyp;
	uint8		ucfr;
	uint32		ufrc;
	uint32		ufix;
	uint32		uint;
	uint32		ulfr;
	uint16		usfr;
	uint16		ushr;
	uint8		uchr;
	char		bool;
	uint8		Str7[8];
	char		str8[8];
	int16		fl16, rect[4];
	uint16		rgbc[3];
} example_rec;

example_rec	example;

/* to pick up the virtual space in-string */
#define rec
#define type
#define hex

static trec example_context[] =
{
	P_TREC(example_rec, Str7),
	C_TREC(example_rec, str8),
	O_TREC(_double, example_rec, doub),
	O_TREC(_float, example_rec, sing),
	O_TREC(_int64, example_rec, llng),
	O_TREC(_ifract, example_rec, ifrc),
	O_TREC(_ifixed, example_rec, ifix),
	O_TREC(_int32, example_rec, lint),
	O_TREC(_int16, example_rec, shrt),
	{_int8, OFFSET(example_rec,ctyp), "char type"},
	O_TREC(_ufract, example_rec, ufrc),
	O_TREC(_ufixed, example_rec, ufix),
	O_TREC(_ufrc16, example_rec, usfr),
	O_TREC(_ufrc32, example_rec, ulfr),
	O_TREC(_uint32, example_rec, uint),
	O_TREC(_uint16, example_rec, ushr),
	O_TREC(_uint8, example_rec, uchr),
	O_TREC(_bool, example_rec, bool type),
	O_TREC(_ufrc8, example_rec, ucfr),
	O_TREC(_hint32, example_rec, ufrc hex),
	O_TREC(_flt16, example_rec, fl16),
	O_TREC(_rgb48, example_rec, rgbc),
	O_TREC(_rect16, example_rec, rect),
	{0},
};

static tcon context_list[] =
{
	O_TCON(example_context, example rec),
	{0}
};

#undef rec
#undef type
#undef hex

int main(int argc,
	char **argv)
{
	FILE		*f = NULL;
	char		**a, *s;
	int		r = 0;

	if (argc<=0 || (a=argv)==NULL)
		return 0;
	if (!--argc || (s=*++a)==NULL)
	{
		fprintf(stderr,"### usage: %s filename\n",
			*argv);
		fputs(
"#\n"
"#  -            use stdin\n"
"#\n",
			stderr);
		return 1;
	}

	if (*s=='-')
	{
		if (!s[1])
			f = stdin, s = "dev::stdin";
		else
		{
			fprintf(stderr,"### %s - unknown option '%s'.\n",
				*argv,s);
			return 1;
		}
	} else
		f = fopen(s,"r");
	if (!f)
	{
		fprintf(stderr,"### %s - could not get/open '%s'.\n",
			*argv,s);
		return 1;
	}
#if !TARGET_API_MAC_CARBON && TARGET_OS_MAC
	if (((volatile char*)0x174)[60>>3]&(0x80>>(60&7))) /* keymap - control */
		Debugger();
#endif
	r = read_ini(f,context_list,~0);
	if (f!=stdin)
		fclose(f);
	if (r)
		fprintf(stderr,"### %s - fatal error (%d).\n",
			*argv,r), r = 1;
	else
		dump_ini(stdout,context_list);

	return r;
}
#endif
